//+------------------------------------------------------------------+
//|                                                                  |
//|                                              SMJones             |
//|                                            sjcoinc2000@yahoo.com |
//|                                Modified to run as Breakout eagle |
//+------------------------------------------------------------------+
#property copyright "SMJones"
#property link      "sjcoinc2000@yahoo.com"


extern int        MagicNumber = 123987;
extern double     Lots = 0.1;
extern bool       AutoMoneyManagement = true;  // percent of accout to risk based on the extern bool
extern double     PercentToRisk = 1;           

extern int        Stop_Loss = 30;
extern int        Take_Profit = 90;
extern int        CancelHour = 23;       
extern int        EndHour  =  9;
extern int        LookBack = 7;          // periods to look back to the highest and the lowest range.
double            HHighest = 0;
double            LLowest =  0;       

int               StartMinute= 0;        
int               PeriodCounter = 60;    // Time frame to look back in.
int               OrderZone = 5;        // this is the zone price can be at maximum and still get a fill. must be larger than TestZone.

int               Slippage = 5;

double            TestZone = 1;          // this is the zone above and below the range for a trade
double            TestRange = 1000;     

 
bool              Buying = true;
bool              Selling = true;
 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+----------------------------------------------------------------------------------------------------------------------+
int start()
  {
//----
// Cancels all pending orders 
//+------------------------------------------------------------------+
      double   Range,
               Spread = Ask - Bid,
               temph, templ, LotTest,
               StopLossH, TakeProfitH,
               StopLossL, TakeProfitL;
      bool     result,
               OkToBuy = true,
               OkToSell = true; 
      string   Currency;
      int      i, type, total = 0,
               StartHour = EndHour + 1; // allows for the full previous hour to be counted and 
                                        // makes the new hour available for orders fro the open.
      total = OrdersTotal();    
    
      if ( Hour() == CancelHour )
         {
            OkToBuy = true; OkToSell = true;
            for(i=total-1;i>=0;i--)
               {
                  OrderSelect(i, SELECT_BY_POS);
                  type   = OrderType();
                  result = false;
    
                  switch(type)
                     {
                        //Close opened long positions
                        case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, CLR_NONE );
                              break;
      
                        //Close opened short positions
                        case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, CLR_NONE );
                              break;

                        //Close pending orders
                        case OP_BUYLIMIT  :
                        case OP_BUYSTOP   :
                        case OP_SELLLIMIT :
                        case OP_SELLSTOP  : result = OrderDelete( OrderTicket() );
                     }
               }
         }    
     
     
     
// Order placing and Lots size are done here
//+------------------------------------------------------------------+     
     
      
      for(i=total-1;i>=0;i--)
         {   
            OrderSelect(i, SELECT_BY_POS);
               type   = OrderType();
               Currency = OrderSymbol();
               
               if ( Currency == Symbol() )
                  {
                     if ( type == OP_BUY ) 
                           {
                              OkToBuy = false;
                           }
                     
                     if ( type == OP_SELL    )
                           {
                              OkToSell = false;
                           } 
                  }
                  
                  
          }      
           
      if ( Hour() == StartHour && (Minute() >= StartMinute && Hour() < StartHour + 1) )
         {
            HHighest = 0; LLowest = 9999999;
            for (i=1; i <= LookBack; i++ )
               {
                        temph = iHigh(NULL, PeriodCounter, i);
                        templ = iLow(NULL, PeriodCounter, i);
                        if ( temph > HHighest ) HHighest = temph;
                        if ( templ < LLowest ) LLowest = templ;
               }
           
         }
      Range = HHighest - LLowest;
      LotTest = Stop_Loss;
      
      StopLossH = Bid - (Stop_Loss * Point);
      StopLossL = Ask + (Stop_Loss * Point);
      TakeProfitH = Ask + (Take_Profit * Point);
      TakeProfitL = Bid - (Take_Profit * Point);           

      if ( AutoMoneyManagement )
          Lots = NormalizeDouble(AccountBalance() * (PercentToRisk / 100) / (LotTest)  / 10,2);
      
      Comment ( "Highest = ", HHighest, "    Lowest = ", LLowest, "    Range = ", (HHighest - LLowest) / Point
                        , "   Bid = ", Bid, "   Ask = ", Ask, "   Lots = ", Lots );

      if ( Bid < HHighest + (TestZone*Point) )
         Buying = true;
      if ( Bid > LLowest - (TestZone*Point) ) 
         Selling = true;                              

      if ( (Hour() >= StartHour && Minute() >= StartMinute) || Hour() > StartHour && Hour() < CancelHour )
         {      
            
                        
            if ( Range <= (TestRange*Point) && Range > 0 )
               {            
                  if (Bid >= HHighest + (TestZone*Point) && Bid <= HHighest + (OrderZone*Point) && OkToBuy && Buying )
                     {
                        OrderSend(Symbol(), OP_BUY, Lots, Ask, Slippage, StopLossH, TakeProfitH, "BreakOut eagle Buy", MagicNumber, NULL, Blue);
                        Buying = false;
                     }      
                  if (Bid <= LLowest - (TestZone*Point)  && Bid >= LLowest - (OrderZone*Point) && OkToSell && Selling )         
                     {
                        OrderSend(Symbol(), OP_SELL, Lots, Bid, Slippage, StopLossL, TakeProfitL, "Breakout eagle Sell", MagicNumber, NULL, Red);
                        Selling = false;
                     }
               }        
        
         }      
      
/*         
Notes:
          
*/   
//----
   return(0);
  }
//+------------------------------------------------------------------+